summarylogtreecommitdiffstats
diff options
context:
space:
mode:
authorGoliathLabs2020-04-26 17:51:21 +0200
committerGoliathLabs2020-04-26 17:51:21 +0200
commitd0a4638d3fca3194d5b45d9359b0a1181f70e39b (patch)
treeda148ac186c00338d4c4c18d549da75324a4c349
downloadaur-d0a4638d3fca3194d5b45d9359b0a1181f70e39b.tar.gz
Added: Initial commit
-rw-r--r--.SRCINFO91
-rw-r--r--PKGBUILD223
-rwxr-xr-xpostgresql-check-db-dir49
-rw-r--r--postgresql-perl-rpath.patch13
-rw-r--r--postgresql-run-socket.patch12
-rw-r--r--postgresql.install25
-rw-r--r--postgresql.logrotate4
-rw-r--r--postgresql.pam3
-rw-r--r--postgresql.service43
-rw-r--r--postgresql.sysusers1
-rw-r--r--postgresql.tmpfiles2
11 files changed, 466 insertions, 0 deletions
diff --git a/.SRCINFO b/.SRCINFO
new file mode 100644
index 00000000000..62b35716efc
--- /dev/null
+++ b/.SRCINFO
@@ -0,0 +1,91 @@
+pkgbase = postgresql-11
+ pkgdesc = Sophisticated object-relational DBMS
+ pkgver = 11.7
+ pkgrel = 1
+ url = https://www.postgresql.org/
+ arch = x86_64
+ license = custom:PostgreSQL
+ makedepends = krb5
+ makedepends = libxml2
+ makedepends = python
+ makedepends = python2
+ makedepends = perl
+ makedepends = tcl>=8.6.0
+ makedepends = openssl>=1.0.0
+ makedepends = pam
+ makedepends = zlib
+ makedepends = icu
+ makedepends = systemd
+ makedepends = libldap
+ makedepends = llvm
+ makedepends = clang
+ source = https://ftp.postgresql.org/pub/source/v11.7/postgresql-11.7.tar.bz2
+ source = postgresql-run-socket.patch
+ source = postgresql-perl-rpath.patch
+ source = postgresql.pam
+ source = postgresql.logrotate
+ source = postgresql.service
+ source = postgresql-check-db-dir
+ source = postgresql.sysusers
+ source = postgresql.tmpfiles
+ sha256sums = 324ae93a8846fbb6a25d562d271bc441ffa8794654c5b2839384834de220a313
+ sha256sums = 8538619cb8bea51078b605ad64fe22abd6050373c7ae3ad6595178da52f6a7d9
+ sha256sums = 5f73b54ca6206bd2c469c507830261ebd167baca074698d8889d769c33f98a31
+ sha256sums = 57dfd072fd7ef0018c6b0a798367aac1abb5979060ff3f9df22d1048bb71c0d5
+ sha256sums = 6abb842764bbed74ea4a269d24f1e73d1c0b1d8ecd6e2e6fb5fb10590298605e
+ sha256sums = 25fb140b90345828dc01a4f286345757e700a47178bab03d217a7a5a79105b57
+ sha256sums = 2bbd8c4e51b70223d274fef3a167af096f44af3d3c41ae505ad11c606674e7c5
+ sha256sums = 7fa8f0ef3f9d40abd4749cc327c2f52478cb6dfb6e2405bd0279c95e9ff99f12
+ sha256sums = 4a4c0bb9ceb156cc47e9446d8393d1f72b4fe9ea1d39ba17213359df9211da57
+ sha512sums = 32c7ace228f9895241ce0d925fbfc60c0cd39f4cd35368fb10dc7db046151ffd59a9895b4c30a529627f0103051e84b4992ed60312cccd292489f3037076ca1e
+ sha512sums = 031efe12d18ce386989062327cdbbe611c5ef1f94e4e1bead502304cb3e2d410af533d3c7f1109d24f9da9708214fe32f9a10ba373a3ca8d507bdb521fbb75f7
+ sha512sums = 38302242b30c01c7981574ed28d9cbd9dc73bf6b56ba3a032afb5d0885ae83e5aa72ce578bf2422214dfa6c46f09d0bdd7cccaeb3c25d58754eb1a34f8bf5615
+ sha512sums = 1e6183ab0eb812b3ef687ac2c26ce78f7cb30540f606d20023669ac00ba04075487fb72e4dc89cc05dab0269ff6aca98fc1167cc75669c225b88b592482fbf67
+ sha512sums = 9ab4da01337ffbab8faec0e220aaa2a642dbfeccf7232ef2645bdc2177a953f17ee3cc14a4d8f8ebd064e1dae8b3dba6029adbffb8afaabea383963213941ba8
+ sha512sums = ee0c010be07e8b5396cfd89c1d077b7c5573753d0210ea4e330e314c2759e25fbee9071e663f871855d65cc8ac75162af9e793dd10892f50f515e7a89cc8d6a0
+ sha512sums = 73af1cd31638791f81aa2623d51188364107a57b55e4deba6691cd99e96ae5ea0dd94b25a0e95d9e21ac64f36f71919a05cd31233c754bde025215a5a02e055c
+ sha512sums = 36f7a5d38370fdc4d4267fd5a8a8330f152a1077bf0f065b89d4a7b8112ccd42be2c46c863791b77de02013f28275a42219f4236e7cb837c3f8cfd5fcc7d3373
+ sha512sums = 5fe81d716d56d515ee4ae1aac56652b7bf20346ea8413482fd9fdb79f0485d8c5ed099f4d2cc460cbe37686488f1354dec433905ce005da8fec772e783addc70
+
+pkgname = postgresql-libs-11
+ pkgdesc = Libraries for use with PostgreSQL
+ depends = krb5
+ depends = openssl>=1.0.0
+ depends = readline>=6.0
+ depends = zlib
+ depends = libldap
+ provides = postgresql-client
+ provides = postgresql-libs=11.7
+ conflicts = postgresql-client
+ conflicts = postgresql-libs
+
+pkgname = postgresql-docs-11
+ pkgdesc = HTML documentation for PostgreSQL
+ provides = postgresql-docs=11.7
+ conflicts = postgresql-docs
+ options = docs
+
+pkgname = postgresql-11
+ pkgdesc = Sophisticated object-relational DBMS
+ install = postgresql.install
+ depends = postgresql-libs>=11.7
+ depends = krb5
+ depends = libxml2
+ depends = readline>=6.0
+ depends = openssl>=1.0.0
+ depends = pam
+ depends = icu
+ depends = systemd-libs
+ depends = libldap
+ depends = llvm-libs
+ optdepends = python2: for PL/Python 2 support
+ optdepends = python: for PL/Python 3 support
+ optdepends = perl: for PL/Perl support
+ optdepends = tcl: for PL/Tcl support
+ optdepends = postgresql-old-upgrade: upgrade from previous major version using pg_upgrade
+ provides = postgresql=11.7
+ conflicts = postgresql
+ options = staticlibs
+ backup = etc/pam.d/postgresql
+ backup = etc/logrotate.d/postgresql
+
diff --git a/PKGBUILD b/PKGBUILD
new file mode 100644
index 00000000000..a37c820cf9d
--- /dev/null
+++ b/PKGBUILD
@@ -0,0 +1,223 @@
+# Maintainer: Felix Golatofski <contact@xdfr.de>
+
+pkgbase=postgresql-11
+pkgname=('postgresql-libs-11' 'postgresql-docs-11' 'postgresql-11')
+pkgver=11.7
+_majorver=${pkgver%.*}
+pkgrel=1
+pkgdesc='Sophisticated object-relational DBMS'
+url='https://www.postgresql.org/'
+arch=('x86_64')
+license=('custom:PostgreSQL')
+makedepends=('krb5' 'libxml2' 'python' 'python2' 'perl' 'tcl>=8.6.0' 'openssl>=1.0.0'
+ 'pam' 'zlib' 'icu' 'systemd' 'libldap' 'llvm' 'clang')
+source=(https://ftp.postgresql.org/pub/source/v${pkgver}/postgresql-${pkgver}.tar.bz2
+ postgresql-run-socket.patch
+ postgresql-perl-rpath.patch
+ postgresql.pam
+ postgresql.logrotate
+ postgresql.service
+ postgresql-check-db-dir
+ postgresql.sysusers
+ postgresql.tmpfiles)
+sha256sums=('324ae93a8846fbb6a25d562d271bc441ffa8794654c5b2839384834de220a313'
+ '8538619cb8bea51078b605ad64fe22abd6050373c7ae3ad6595178da52f6a7d9'
+ '5f73b54ca6206bd2c469c507830261ebd167baca074698d8889d769c33f98a31'
+ '57dfd072fd7ef0018c6b0a798367aac1abb5979060ff3f9df22d1048bb71c0d5'
+ '6abb842764bbed74ea4a269d24f1e73d1c0b1d8ecd6e2e6fb5fb10590298605e'
+ '25fb140b90345828dc01a4f286345757e700a47178bab03d217a7a5a79105b57'
+ '2bbd8c4e51b70223d274fef3a167af096f44af3d3c41ae505ad11c606674e7c5'
+ '7fa8f0ef3f9d40abd4749cc327c2f52478cb6dfb6e2405bd0279c95e9ff99f12'
+ '4a4c0bb9ceb156cc47e9446d8393d1f72b4fe9ea1d39ba17213359df9211da57')
+sha512sums=('32c7ace228f9895241ce0d925fbfc60c0cd39f4cd35368fb10dc7db046151ffd59a9895b4c30a529627f0103051e84b4992ed60312cccd292489f3037076ca1e'
+ '031efe12d18ce386989062327cdbbe611c5ef1f94e4e1bead502304cb3e2d410af533d3c7f1109d24f9da9708214fe32f9a10ba373a3ca8d507bdb521fbb75f7'
+ '38302242b30c01c7981574ed28d9cbd9dc73bf6b56ba3a032afb5d0885ae83e5aa72ce578bf2422214dfa6c46f09d0bdd7cccaeb3c25d58754eb1a34f8bf5615'
+ '1e6183ab0eb812b3ef687ac2c26ce78f7cb30540f606d20023669ac00ba04075487fb72e4dc89cc05dab0269ff6aca98fc1167cc75669c225b88b592482fbf67'
+ '9ab4da01337ffbab8faec0e220aaa2a642dbfeccf7232ef2645bdc2177a953f17ee3cc14a4d8f8ebd064e1dae8b3dba6029adbffb8afaabea383963213941ba8'
+ 'ee0c010be07e8b5396cfd89c1d077b7c5573753d0210ea4e330e314c2759e25fbee9071e663f871855d65cc8ac75162af9e793dd10892f50f515e7a89cc8d6a0'
+ '73af1cd31638791f81aa2623d51188364107a57b55e4deba6691cd99e96ae5ea0dd94b25a0e95d9e21ac64f36f71919a05cd31233c754bde025215a5a02e055c'
+ '36f7a5d38370fdc4d4267fd5a8a8330f152a1077bf0f065b89d4a7b8112ccd42be2c46c863791b77de02013f28275a42219f4236e7cb837c3f8cfd5fcc7d3373'
+ '5fe81d716d56d515ee4ae1aac56652b7bf20346ea8413482fd9fdb79f0485d8c5ed099f4d2cc460cbe37686488f1354dec433905ce005da8fec772e783addc70')
+
+prepare() {
+ cd postgresql-${pkgver}
+ patch -p1 < ../postgresql-run-socket.patch
+ patch -p1 < ../postgresql-perl-rpath.patch
+}
+
+build() {
+ cd postgresql-${pkgver}
+ local options=(
+ --prefix=/usr
+ --mandir=/usr/share/man
+ --datadir=/usr/share/postgresql
+ --sysconfdir=/etc
+ --with-gssapi
+ --with-libxml
+ --with-openssl
+ --with-perl
+ --with-python
+ --with-tcl
+ --with-pam
+ --with-system-tzdata=/usr/share/zoneinfo
+ --with-uuid=e2fs
+ --with-icu
+ --with-systemd
+ --with-ldap
+ --with-llvm
+ --enable-nls
+ --enable-thread-safety
+ --disable-rpath
+ )
+
+ # only build plpython3 for now
+ ./configure ${options[@]} \
+ PYTHON=/usr/bin/python
+ make -C src/pl/plpython all
+ make -C contrib/hstore_plpython all
+ make -C contrib/ltree_plpython all
+
+ # save plpython3 build and Makefile.global
+ cp -a src/pl/plpython{,3}
+ cp -a contrib/hstore_plpython{,3}
+ cp -a contrib/ltree_plpython{,3}
+ cp -a src/Makefile.global{,.python3}
+ make distclean
+
+ # regular build with everything
+ ./configure ${options[@]} \
+ PYTHON=/usr/bin/python2
+ make world
+}
+
+_postgres_check() {
+ make "${1}" || (find . -name regression.diffs | \
+ while read -r line; do
+ error "make ${1} failure: ${line}"
+ cat "${line}"
+ done; exit 1)
+}
+
+check() {
+ cd postgresql-${pkgver}
+ _postgres_check check
+ _postgres_check check-world
+}
+
+package_postgresql-libs-11() {
+ pkgdesc="Libraries for use with PostgreSQL"
+ depends=('krb5' 'openssl>=1.0.0' 'readline>=6.0' 'zlib' 'libldap')
+ provides=('postgresql-client' "postgresql-libs=$pkgver")
+ conflicts=('postgresql-client' 'postgresql-libs')
+
+ cd postgresql-${pkgver}
+
+ # install license
+ install -Dm 644 COPYRIGHT -t "${pkgdir}/usr/share/licenses/${pkgname}"
+
+ # install libs and non-server binaries
+ for dir in src/interfaces src/bin/pg_config src/bin/pg_dump src/bin/psql src/bin/scripts; do
+ make -C ${dir} DESTDIR="${pkgdir}" install
+ done
+
+ for util in pg_config pg_dump pg_dumpall pg_restore psql \
+ clusterdb createdb createuser dropdb dropuser pg_isready reindexdb vacuumdb; do
+ install -Dm 644 doc/src/sgml/man1/${util}.1 "${pkgdir}"/usr/share/man/man1/${util}.1
+ done
+
+ cd src/include
+
+ install -d "${pkgdir}"/usr/include/{libpq,postgresql/internal/libpq}
+
+ # these headers are needed by the public headers of the interfaces
+ install -m 644 pg_config.h "${pkgdir}/usr/include"
+ install -m 644 pg_config_os.h "${pkgdir}/usr/include"
+ install -m 644 pg_config_ext.h "${pkgdir}/usr/include"
+ install -m 644 postgres_ext.h "${pkgdir}/usr/include"
+ install -m 644 libpq/libpq-fs.h "${pkgdir}/usr/include/libpq"
+ install -m 644 pg_config_manual.h "${pkgdir}/usr/include"
+
+ # these he aders are needed by the not-so-public headers of the interfaces
+ install -m 644 c.h "${pkgdir}/usr/include/postgresql/internal"
+ install -m 644 port.h "${pkgdir}/usr/include/postgresql/internal"
+ install -m 644 postgres_fe.h "${pkgdir}/usr/include/postgresql/internal"
+ install -m 644 libpq/pqcomm.h "${pkgdir}/usr/include/postgresql/internal/libpq"
+}
+
+package_postgresql-docs-11() {
+ pkgdesc="HTML documentation for PostgreSQL"
+ options=('docs')
+ provides=("postgresql-docs=$pkgver")
+ conflicts=('postgresql-docs')
+
+ cd postgresql-${pkgver}
+
+ install -Dm 644 COPYRIGHT -t "${pkgdir}/usr/share/licenses/${pkgname}"
+
+ make -C doc/src/sgml DESTDIR="${pkgdir}" install-html
+ chown -R root:root "${pkgdir}/usr/share/doc/postgresql/html"
+
+ # clean up
+ rmdir "${pkgdir}"/usr/share/man/man{1,3,7}
+ rmdir "${pkgdir}"/usr/share/man
+}
+
+package_postgresql-11() {
+ pkgdesc='Sophisticated object-relational DBMS'
+ backup=('etc/pam.d/postgresql' 'etc/logrotate.d/postgresql')
+ depends=("postgresql-libs>=${pkgver}" 'krb5' 'libxml2' 'readline>=6.0' 'openssl>=1.0.0' 'pam' 'icu' 'systemd-libs' 'libldap' 'llvm-libs')
+ optdepends=('python2: for PL/Python 2 support'
+ 'python: for PL/Python 3 support'
+ 'perl: for PL/Perl support'
+ 'tcl: for PL/Tcl support'
+ 'postgresql-old-upgrade: upgrade from previous major version using pg_upgrade')
+ provides=("postgresql=$pkgver")
+ conflicts=('postgresql')
+ options=('staticlibs')
+ install=postgresql.install
+
+ cd postgresql-${pkgver}
+
+ # install
+ make DESTDIR="${pkgdir}" install
+ make -C contrib DESTDIR="${pkgdir}" install
+ make -C doc/src/sgml DESTDIR="${pkgdir}" install-man
+
+ # install plpython3
+ mv src/Makefile.global src/Makefile.global.save
+ cp src/Makefile.global.python3 src/Makefile.global
+ touch -r src/Makefile.global.save src/Makefile.global
+ make -C src/pl/plpython3 DESTDIR="${pkgdir}" install
+ make -C contrib/hstore_plpython3 DESTDIR="${pkgdir}" install
+ make -C contrib/ltree_plpython3 DESTDIR="${pkgdir}" install
+
+ # we don't want these, they are in the -libs package
+ for dir in src/interfaces src/bin/pg_config src/bin/pg_dump src/bin/psql src/bin/scripts; do
+ make -C ${dir} DESTDIR="${pkgdir}" uninstall
+ done
+ for util in pg_config pg_dump pg_dumpall pg_restore psql \
+ clusterdb createdb createuser dropdb dropuser pg_isready reindexdb vacuumdb; do
+ rm "${pkgdir}"/usr/share/man/man1/${util}.1
+ done
+
+ install -Dm 644 COPYRIGHT -t "${pkgdir}/usr/share/licenses/${pkgname}"
+
+ cd "${srcdir}"
+ install -Dm 755 postgresql-check-db-dir -t "${pkgdir}/usr/bin"
+
+ install -Dm 644 postgresql.pam "${pkgdir}/etc/pam.d/postgresql"
+ install -Dm 644 postgresql.logrotate "${pkgdir}/etc/logrotate.d/postgresql"
+
+ install -Dm 644 postgresql.service -t "${pkgdir}/usr/lib/systemd/system"
+ install -Dm 644 postgresql.sysusers "${pkgdir}/usr/lib/sysusers.d/postgresql.conf"
+ install -Dm 644 postgresql.tmpfiles "${pkgdir}/usr/lib/tmpfiles.d/postgresql.conf"
+
+ # clean up unneeded installed items
+ rm -rf "${pkgdir}/usr/include/postgresql/internal"
+ rm -rf "${pkgdir}/usr/include/libpq"
+ find "${pkgdir}/usr/include" -maxdepth 1 -type f -execdir rm {} +
+ rmdir "${pkgdir}/usr/share/doc/postgresql/html"
+}
+
+# vim: ts=2 sw=2 et:
+
diff --git a/postgresql-check-db-dir b/postgresql-check-db-dir
new file mode 100755
index 00000000000..fabca97e2c4
--- /dev/null
+++ b/postgresql-check-db-dir
@@ -0,0 +1,49 @@
+#!/bin/sh
+
+# This script verifies that the postgresql data directory has been correctly
+# initialized. We do not want to automatically initdb it, because that has
+# a risk of catastrophic failure (ie, overwriting a valuable database) in
+# corner cases, such as a remotely mounted database on a volume that's a
+# bit slow to mount. But we can at least emit a message advising newbies
+# what to do.
+
+PGDATA="$1"
+
+if [ -z "$PGDATA" ]
+then
+ echo "Usage: $0 database-path"
+ exit 1
+fi
+
+# PGMAJORVERSION is major version
+PGMAJORVERSION=11
+# PREVMAJORVERSION is the previous major version
+PREVMAJORVERSION=10
+
+# Check for the PGDATA structure
+if [ -f "$PGDATA/PG_VERSION" ] && [ -d "$PGDATA/base" ]
+then
+ # Check version of existing PGDATA
+ if [ x`cat "$PGDATA/PG_VERSION"` = x"$PGMAJORVERSION" ]
+ then
+ : A-OK
+ elif [ x`cat "$PGDATA/PG_VERSION"` = x"$PREVMAJORVERSION" ]
+ then
+ echo $"An old version of the database format was found."
+ echo $"See https://wiki.archlinux.org/index.php/PostgreSQL#Upgrading_PostgreSQL"
+ exit 1
+ else
+ echo $"An old version of the database format was found."
+ echo $"You need to dump and reload before using PostgreSQL $PGMAJORVERSION."
+ echo $"See http://www.postgresql.org/docs/$PGMAJORVERSION/static/upgrading.html"
+ exit 1
+ fi
+else
+ # No existing PGDATA! Warn the user to initdb it.
+ echo $"\"$PGDATA\" is missing or empty. Use a command like"
+ echo $" su - postgres -c \"initdb --locale en_US.UTF-8 -D '$PGDATA'\""
+ echo $"with relevant options, to initialize the database cluster."
+ exit 1
+fi
+
+exit 0
diff --git a/postgresql-perl-rpath.patch b/postgresql-perl-rpath.patch
new file mode 100644
index 00000000000..c4c4fdad289
--- /dev/null
+++ b/postgresql-perl-rpath.patch
@@ -0,0 +1,13 @@
+diff -Naur postgresql-9.1.5.orig/src/pl/plperl/GNUmakefile postgresql-9.1.5/src/pl/plperl/GNUmakefile
+--- postgresql-9.1.5.orig/src/pl/plperl/GNUmakefile 2012-08-14 18:41:04.000000000 -0400
++++ postgresql-9.1.5/src/pl/plperl/GNUmakefile 2012-08-17 11:15:09.457116708 -0400
+@@ -43,6 +43,9 @@
+
+ SHLIB_LINK = $(perl_embed_ldflags)
+
++# Force rpath to be used even though we disable it everywhere else
++SHLIB_LINK += $(rpath)
++
+ REGRESS_OPTS = --dbname=$(PL_TESTDB) --load-extension=plperl --load-extension=plperlu
+ REGRESS = plperl plperl_lc plperl_trigger plperl_shared plperl_elog plperl_util plperl_init plperlu plperl_array
+ # if Perl can support two interpreters in one backend,
diff --git a/postgresql-run-socket.patch b/postgresql-run-socket.patch
new file mode 100644
index 00000000000..b558c7b7496
--- /dev/null
+++ b/postgresql-run-socket.patch
@@ -0,0 +1,12 @@
+diff -Naur postgresql-9.2.0.sockets/src/include/pg_config_manual.h postgresql-9.2.0/src/include/pg_config_manual.h
+--- postgresql-9.2.0.sockets/src/include/pg_config_manual.h 2012-09-06 17:26:17.000000000 -0400
++++ postgresql-9.2.0/src/include/pg_config_manual.h 2012-09-06 18:13:18.183092471 -0400
+@@ -144,7 +144,7 @@
+ * here's where to twiddle it. You can also override this at runtime
+ * with the postmaster's -k switch.
+ */
+-#define DEFAULT_PGSOCKET_DIR "/tmp"
++#define DEFAULT_PGSOCKET_DIR "/run/postgresql"
+
+ /*
+ * The random() function is expected to yield values between 0 and
diff --git a/postgresql.install b/postgresql.install
new file mode 100644
index 00000000000..0d23d474a0c
--- /dev/null
+++ b/postgresql.install
@@ -0,0 +1,25 @@
+post_install() {
+ if [ ! -d '/var/lib/postgres' ]; then
+ mkdir -p '/var/lib/postgres'
+ fi
+ if ! getent group postgres >/dev/null; then
+ groupadd -g 88 postgres
+ fi
+ if ! getent passwd postgres >/dev/null; then
+ useradd -c 'PostgreSQL user' -u 88 -g postgres -d '/var/lib/postgres' -s /bin/bash postgres
+ passwd -l postgres >/dev/null
+ fi
+ if [ ! -d '/var/lib/postgres/data' ]; then
+ mkdir -p '/var/lib/postgres/data'
+ chown postgres:postgres '/var/lib/postgres/data'
+ fi
+}
+
+post_upgrade() {
+ post_install $1
+ # FS#23858, fix postgres user shell issue
+ postgres_shell=$(getent passwd postgres | cut -d: -f7)
+ if [ "$postgres_shell" = "/sbin/nologin" ]; then
+ chsh -s /bin/bash postgres
+ fi
+}
diff --git a/postgresql.logrotate b/postgresql.logrotate
new file mode 100644
index 00000000000..9c36918be5e
--- /dev/null
+++ b/postgresql.logrotate
@@ -0,0 +1,4 @@
+/var/log/postgresql.log {
+ copytruncate
+ missingok
+}
diff --git a/postgresql.pam b/postgresql.pam
new file mode 100644
index 00000000000..53724d1f86a
--- /dev/null
+++ b/postgresql.pam
@@ -0,0 +1,3 @@
+auth required pam_unix.so
+account required pam_unix.so
+session required pam_unix.so
diff --git a/postgresql.service b/postgresql.service
new file mode 100644
index 00000000000..dcef95a9c10
--- /dev/null
+++ b/postgresql.service
@@ -0,0 +1,43 @@
+[Unit]
+Description=PostgreSQL database server
+After=network.target
+
+[Service]
+Type=notify
+TimeoutSec=120
+User=postgres
+Group=postgres
+
+Environment=PGROOT=/var/lib/postgres
+
+SyslogIdentifier=postgres
+PIDFile=/var/lib/postgres/data/postmaster.pid
+RuntimeDirectory=postgresql
+RuntimeDirectoryMode=755
+
+ExecStartPre=/usr/bin/postgresql-check-db-dir ${PGROOT}/data
+ExecStart=/usr/bin/postgres -D ${PGROOT}/data
+ExecReload=/bin/kill -HUP ${MAINPID}
+KillMode=mixed
+KillSignal=SIGINT
+
+# Due to PostgreSQL's use of shared memory, OOM killer is often overzealous in
+# killing Postgres, so adjust it downward
+OOMScoreAdjust=-200
+
+# Additional security-related features
+PrivateTmp=true
+ProtectHome=true
+ProtectSystem=full
+NoNewPrivileges=true
+ProtectControlGroups=true
+ProtectKernelModules=true
+ProtectKernelTunables=true
+PrivateDevices=true
+RestrictAddressFamilies=AF_UNIX AF_INET AF_INET6
+RestrictNamespaces=true
+RestrictRealtime=true
+SystemCallArchitectures=native
+
+[Install]
+WantedBy=multi-user.target
diff --git a/postgresql.sysusers b/postgresql.sysusers
new file mode 100644
index 00000000000..a1711b1cc3d
--- /dev/null
+++ b/postgresql.sysusers
@@ -0,0 +1 @@
+u postgres - "PostgreSQL user" /var/lib/postgres /bin/bash
diff --git a/postgresql.tmpfiles b/postgresql.tmpfiles
new file mode 100644
index 00000000000..e618918018a
--- /dev/null
+++ b/postgresql.tmpfiles
@@ -0,0 +1,2 @@
+d /var/lib/postgres/data 700 postgres postgres
+h /var/lib/postgres/data - - - - +C